#include < amxmodx >
#include < hamsandwich >
#include < fakemeta >
#include < ColorChat >

#include < ncodmod >

new bool:gbHasClass[ 33 ] = false;

public plugin_init( )
{
	ncod_registerClass( 
		"Czarnoskory Wojownik",
		"Posiada maczete 1/2 z lpm, scouta 1/3, gail'a oraz glock'a.",
		10, 5, 10, 5,
		( 1 << CSW_SCOUT | 1 << CSW_GALIL | 1 << CSW_GLOCK18 ),
		NCODTEAM_TERRORIST
	);
	
	RegisterHam( Ham_TakeDamage, "player", "hamTakeDamage" );
	RegisterHam( Ham_Item_Deploy, "weapon_knife", "hamItemDeployKnife", 1 );
}

public plugin_precache( )
	precache_model( "models/NCodMod/v_machete.mdl" )

public ncod_classChangeState( id, iClass, NCodState:iState )
{
	switch( iState )
	{
		case NCODSTATE_DISABLE: 
			gbHasClass[ id ] = false;
		
		case NCODSTATE_ENABLE: 
			gbHasClass[ id ] = true;
		
		default: return;
	}
}

public hamTakeDamage( iThis, iInflictor, iAttacker, Float:fDamage, iDamageBits )
{
	if( !is_user_connected( iAttacker ) || !gbHasClass[ iAttacker ] )
		return HAM_IGNORED;
		
	switch( get_user_weapon( iAttacker ) )
	{
		case CSW_KNIFE: if( random( 1 ) ) return HAM_IGNORED;
		case CSW_SCOUT: if( random( 2 ) ) return HAM_IGNORED;
		
		default: return HAM_IGNORED;
	}
	
	set_pev( iThis, pev_armorvalue, 0 );
	SetHamParamFloat( 4, pev( iThis, pev_health ) + 1.0 );
	
	return HAM_HANDLED ;
}

public hamItemDeployKnife( iEnt )
{
	static iOwner;
	iOwner = pev( iEnt, pev_owner );
	
	if( !gbHasClass[ iOwner ] )
		return HAM_IGNORED;
		
	set_pev( iOwner, pev_viewmodel2, "models/NCodMod/v_machete.mdl" );
	
	return HAM_IGNORED;
	
}