#include < amxmodx >
#include < hamsandwich >
#include < fakemeta_util >
#include < ColorChat >

#include "ncodmod.inc"

new bool:gbHasClass[ 33 ] = false;
new giMinesNum[ 33 ];
new giSprite;

public plugin_init( )
{
	ncod_registerClass( 
		"Osama [ Premium ]",
		"Posiada awp 1/2, m4 1/10, 4 miny i deagle. Gdy kuca jest mniej widoczny.",
		100, -5, 50, -10,
		( 1 << CSW_AWP | 1 << CSW_M4A1 | 1 << CSW_DEAGLE ),
		NCODTEAM_TERRORIST,
		ADMIN_LEVEL_G
	);
	
	RegisterHam( Ham_TakeDamage, "player", "hamTakeDamage" );
	
	register_forward( FM_Touch, "fwTouch" );
	register_forward( FM_CmdStart, "fwCmdStart" );
	
	ncod_registerHUDAddon( );
}

public plugin_precache( )
{
	giSprite = precache_model( "sprites/blast.spr" ) ;
	precache_model( "models/NCodMod/mine.mdl" );
}

public ncod_classChangeState( id, iClass, NCodState:iState )
{
	switch( iState )
	{
		case NCODSTATE_DISABLE: 
			gbHasClass[ id ] = false;
		
		case NCODSTATE_ENABLE: 
			gbHasClass[ id ] = true;
		
		case NCODSTATE_USE: 
		{
			if( !is_user_alive( id ) )
				return ;
			
			if( !giMinesNum[ id ] )
			{
				ncod_printInformation( id, NCODINFOTYPE_CHAT, NCODINFOCOLOR_NORMAL, "Nie masz wiecej min!" );
				return;
			}
			
			giMinesNum[ id ] --;
			
			new Float:fOrigin[ 3 ];
			pev( id, pev_origin, fOrigin );

			new iMine = engfunc( EngFunc_CreateNamedEntity, engfunc( EngFunc_AllocString, "info_target" ) );

			set_pev( iMine, pev_classname, "ncod_mine" );
			set_pev( iMine, pev_owner, id );
			set_pev( iMine, pev_movetype, MOVETYPE_TOSS );
			set_pev( iMine, pev_solid, SOLID_BBOX );

			engfunc( EngFunc_SetModel, iMine, "models/NCodMod/mine.mdl" )
			engfunc( EngFunc_SetSize, iMine, Float:{ -16.0, -16.0, 0.0 }, Float:{ 16.0, 16.0, 2.0 } );
			engfunc( EngFunc_DropToFloor, iMine );

			fm_set_rendering( iMine, kRenderFxNone, 0, 0, 0, kRenderTransTexture, 50 );
		}
		
		case NCODSTATE_SPAWN:
			giMinesNum[ id ] = 3;
		
		default: return;
	}
}

public ncod_hudRefresh( id, szText[ 128 ] )
{
	if( !gbHasClass[ id ] )
		return;
		
	format( szText, 127, "[ Miny ]: %d", giMinesNum[ id ] );
}

public hamTakeDamage( iThis, iInflictor, iAttacker, Float:fDamage, iDamageBits )
{
	if( !is_user_connected( iAttacker ) || !gbHasClass[ iAttacker ] )
		return HAM_IGNORED;
		
	switch( get_user_weapon( iAttacker ) )
	{
		case CSW_AWP: if( random( 1 ) ) return HAM_IGNORED;
		case CSW_M4A1: if( random( 11 ) ) return HAM_IGNORED;
		
		default: return HAM_IGNORED;
	}
	
	set_pev( iThis, pev_armorvalue, 0 );
	SetHamParamFloat( 4, pev( iThis, pev_health ) + 1.0 );
	
	return HAM_HANDLED ;
}

public fwTouch( id, iEnt )
{
	if( !pev_valid( iEnt ) )
		return FMRES_IGNORED;
	
	new szClassName[ 33 ];
	pev( iEnt, pev_classname, szClassName, 32 );
	
	if( !is_user_alive( id ) || !equali( szClassName, "ncod_mine" ) )
		return FMRES_IGNORED;
		
	new iAttacker = pev( iEnt, pev_owner );
	
	if( !gbHasClass[ iAttacker ] )
		return FMRES_IGNORED;
	
	new Float:fOrigin[ 3 ];
	pev( iEnt, pev_origin, fOrigin );
	
	engfunc( EngFunc_RemoveEntity, iEnt );
	
	message_begin( MSG_BROADCAST, SVC_TEMPENTITY );
	write_byte( TE_EXPLOSION );
	engfunc( EngFunc_WriteCoord, fOrigin[ 0 ] );
	engfunc( EngFunc_WriteCoord, fOrigin[ 1 ] );
	engfunc( EngFunc_WriteCoord, fOrigin[ 2 ] );
	write_short( giSprite );
	write_byte( 32 );
	write_byte( 20 );
	write_byte( 0 );
	message_end( );
	
	ExecuteHamB( Ham_TakeDamage, id, iAttacker, iAttacker, 30.0, DMG_BLAST );

	
	return HAM_IGNORED;
}

public fwCmdStart( id, iUC )
{
	if( !is_user_alive( id ) || !gbHasClass[ id ] )
		return FMRES_IGNORED;
		
	if( get_uc( iUC, UC_Buttons ) & IN_DUCK )
		fm_set_user_rendering( id, kRenderFxGlowShell, 0, 0, 0, kRenderTransAlpha, 90 );
	else
		fm_set_user_rendering( id, kRenderFxGlowShell, 0, 0, 0, kRenderTransAlpha, 255 );
		
	return FMRES_IGNORED;
}