#include < amxmodx >
#include < hamsandwich >
#include < fakemeta_util >
#include < ColorChat >

#include "ncodmod.inc"

new bool:gbHasClass[ 33 ] = false;
new giMedkits[ 33 ]; 

public plugin_init( )
{
	ncod_registerClass( 
		"SEAL",
		"Posiada wiertare TMP 1/15, usp 1/10, 2 flashe i 2 apteczki.",
		-25, 0, 25, 55,
		( 1 << CSW_TMP | 1 << CSW_USP | 1 << CSW_FLASHBANG | 1 << CSW_FLASHBANG ),
		NCODTEAM_AMERICA
	);
	
	RegisterHam( Ham_TakeDamage, "player", "hamTakeDamage" );
	
	ncod_registerHUDAddon( );
}

public ncod_classChangeState( id, iClass, NCodState:iState )
{
	switch( iState )
	{
		case NCODSTATE_DISABLE: 
			gbHasClass[ id ] = false;
		
		case NCODSTATE_ENABLE: 
			gbHasClass[ id ] = true;
		
		case NCODSTATE_USE: 
		{
				if( !giMedkits[ id ] )
				{
					ncod_printInformation( id, NCODINFOTYPE_CHAT, NCODINFOCOLOR_NORMAL, "Nie posiadasz wiecej apteczek !" );
					return;
				}
				
				new Float:fMaxHealth = 100.0 + ncod_getUserStatist( id, NCODSTATIST_HEALTH );
				if( get_user_health( id ) == fMaxHealth )
					return;
					
				giMedkits[ id ] --;
					
				set_pev( id, pev_health, fMaxHealth );
		}
		
		case NCODSTATE_SPAWN:
			giMedkits[ id ] = 2;
		
		default: return;
	}
}

public ncod_hudRefresh( id, szText[ 128 ] )
{
	if( !gbHasClass[ id ] )
		return;
		
	formatex( szText, 127, "[ Apteczki ]: %d", giMedkits[ id ] );
}

public hamTakeDamage( iThis, iInflictor, iAttacker, Float:fDamage, iDamageBits )
{
	if( !is_user_connected( iAttacker ) || !gbHasClass[ iAttacker ] )
		return HAM_IGNORED;
		
	switch( get_user_weapon( iAttacker ) )
	{
		case CSW_TMP: if( random( 14 ) ) return HAM_IGNORED;
		case CSW_USP: if( random( 9 ) ) return HAM_IGNORED;
		
		default: return HAM_IGNORED;
	}
	
	set_pev( iThis, pev_armorvalue, 0 );
	SetHamParamFloat( 4, pev( iThis, pev_health ) + 1.0 );
	
	return HAM_HANDLED ;
}