#include < amxmodx >
#include < fakemeta_util >
#include < hamsandwich >

#include "ncodmod.inc"

new bool: gHasPerk[ 33 ] = { false };

stock const Float:gfWeaponDelay[CSW_P90+1] = {
	0.00, 2.70, 0.00, 2.00, 0.00, 0.55, 0.00, 3.15, 3.30, 0.00, 4.50, 
	2.70, 3.50, 3.35, 2.45, 3.30, 2.70, 2.20, 2.50, 2.63, 4.70, 
	0.55, 3.05, 2.12, 3.50, 0.00, 2.20, 3.00, 2.45, 0.00, 3.40
}

public plugin_init( )
{
	ncod_registerPerk( 
			"Szybkie Rece",
			"Szybciej przeladowywujesz"
	);
	
	new szWeapon[ 17 ];
	new iBadWeapons = ( ( 1 << CSW_HEGRENADE ) | ( 1 << CSW_SMOKEGRENADE ) | ( 1 << CSW_FLASHBANG ) | ( 1 << CSW_M3 ) | ( 1 << CSW_XM1014 ) );
	
	for( new i = 1 ; i < CSW_P90; i++ )
		if( !( iBadWeapons & ( 1 << i ) ) && get_weaponname( i, szWeapon, 16 ) )
			RegisterHam( Ham_Weapon_Reload, szWeapon, "hamWeaponReloadPost", 1 );
}

public hamWeaponReloadPost( iWeapon )
{
	static iOwner;
	iOwner = get_pdata_cbase( iWeapon, 41, 4 );

	if( ! gHasPerk[ iOwner ] || ! get_pdata_int( iWeapon, 54, 4 ) )
		return;
		
	static Float: fDelay;
	fDelay = gfWeaponDelay[ get_pdata_int( iWeapon, 43, 4 ) ] * 0.35;
	
	set_pdata_float( iOwner, 83, fDelay, 4 );
	set_pdata_float( iWeapon, 48, fDelay + 0.5, 4 ); 
	set_task( fDelay, "tastReloadEnd", iOwner );
}

public tastReloadEnd( id )
{
	set_pev( id, pev_weaponanim, 0 )
	
	message_begin( MSG_ONE, SVC_WEAPONANIM, _, id )
	write_byte( 0 )
	write_byte( pev( id, pev_body ) )
	message_end( )
}

public ncod_perkChangeState( id, iPerk, NCodState: iState )
{
	switch( iState )
	{
		case NCODSTATE_ENABLE: gHasPerk[ id ] = true;
		case NCODSTATE_DISABLE: gHasPerk[ id ] = false;
		default: {}
	}
}