#include < amxmodx >
#include < hamsandwich >
#include < fakemeta_util >
#include < ColorChat >

#include "ncodmod.inc"

new bool:gbHasClass[ 33 ] = false;
new giRocketsNum[ 33 ] = { 0 };
new Float:gfNextAttack[ 33 ];
new giSprite;

public plugin_init( )
{
	ncod_registerClass( 
		"Allah [ Premium ]",
		"Posiada 3 rakietki, ak47 1/10, scouta 1/3, 1/2 z kosy PPM. Na nożu mniej widoczny.",
		30, -25, 50, 5,
		( 1 << CSW_AK47 | 1 << CSW_SCOUT ),
		NCODTEAM_TERRORIST,
		ADMIN_LEVEL_G
	);
	
	RegisterHam( Ham_TakeDamage, "player", "hamTakeDamage" );
	RegisterHam( Ham_Item_Holster, "weapon_knife", "hamItemHolster" );
	
	register_forward( FM_Touch, "fwTouch" );
	
	ncod_registerHUDAddon( );
}

public plugin_precache( )
{
	giSprite = precache_model( "sprites/blast.spr" ) ;
	precache_model( "models/rpgrocket.mdl" );
}

public ncod_classChangeState( id, iClass, NCodState:iState )
{
	switch( iState )
	{
		case NCODSTATE_DISABLE: 
			gbHasClass[ id ] = false;
		
		case NCODSTATE_ENABLE: 
			gbHasClass[ id ] = true;
		
		case NCODSTATE_USE: 
		{
			if( !is_user_alive( id ) )
				return ;
			
			if( !giRocketsNum[ id ] )
			{
				ncod_printInformation( id, NCODINFOTYPE_CHAT, NCODINFOCOLOR_NORMAL, "Rakiet mozesz uzywac co 2 sekundy!" );
				return;

			}
			if( gfNextAttack[ id ] >= get_gametime() )
			{
				ncod_printInformation( id, NCODINFOTYPE_CHAT, NCODINFOCOLOR_NORMAL, "Rakiet mozesz uzywac co 2 sekundy!" );
			}
			else
			{
				gfNextAttack[ id ] = get_gametime() + 2.0;
				giRocketsNum[ id ] --;

				new Float: fTemp[ 3 ];

				new iRocket = engfunc( EngFunc_CreateNamedEntity, engfunc( EngFunc_AllocString, "info_target" ) );
				set_pev( iRocket, pev_classname, "ncod_rocket" );
				engfunc( EngFunc_SetModel, iRocket, "models/rpgrocket.mdl" );

				pev( id, pev_v_angle, fTemp );
				fTemp[ 0 ] *= -1.0;
				set_pev( iRocket, pev_angles, fTemp );
				
				pev( id, pev_origin, fTemp );
				set_pev( iRocket, pev_origin, fTemp );

				set_pev( iRocket, pev_effects, 2 );
				set_pev( iRocket, pev_solid, SOLID_BBOX );
				set_pev( iRocket, pev_movetype, MOVETYPE_FLY )
				set_pev( iRocket, pev_owner, id )

				velocity_by_aim( id, 1000, fTemp );
				set_pev( iRocket, pev_velocity, fTemp );
			}
		}
		
		case NCODSTATE_SPAWN:
			giRocketsNum[ id ] = 3;
		
		default: return;
	}
}

public ncod_hudRefresh( id, szText[ 128 ] )
{
	if( !gbHasClass[ id ] )
		return;
		
	formatex( szText, 127, "[ Rakiety ]: %d", giRocketsNum[ id ] );
}

public hamTakeDamage( iThis, iInflictor, iAttacker, Float:fDamage, iDamageBits )
{
	if( !is_user_connected( iAttacker ) || !gbHasClass[ iAttacker ] )
		return HAM_IGNORED;
		
	switch( get_user_weapon( iAttacker ) )
	{
		case CSW_AK47: if( random( 9 ) ) return HAM_IGNORED;
		case CSW_SCOUT: if( random( 2 ) ) return HAM_IGNORED;
		case CSW_KNIFE: if( random( 1 ) ) return HAM_IGNORED;
		
		default: return HAM_IGNORED;
	}
	
	set_pev( iThis, pev_armorvalue, 0 );
	SetHamParamFloat( 4, pev( iThis, pev_health ) + 1.0 );
	
	return HAM_HANDLED ;
}

public hamItemHolster( iWeapon )
{
	static iOwner;
	iOwner = pev( iWeapon, pev_owner );
	
	if( !gbHasClass[ iOwner ] )
		return HAM_IGNORED;
	
	if( get_user_weapon( iOwner ) == CSW_KNIFE )
		fm_set_rendering( iOwner, kRenderFxGlowShell, 0, 0, 0, kRenderTransAlpha, 127 );
	else
		fm_set_rendering( iOwner, kRenderFxGlowShell, 0, 0, 0, kRenderTransAlpha, 255 );
		
	return HAM_IGNORED ;
}

public fwTouch( iSomething, iEnt )
{
	if( !pev_valid( iEnt ) )
		return FMRES_IGNORED;

	new szClassName[ 33 ];
	pev( iEnt, pev_classname, szClassName, 32 );
	
	if( !equali( szClassName, "ncod_rocket" ) )
		return FMRES_IGNORED;
		
	new iAttacker = pev( iEnt, pev_owner );
	
	if( !gbHasClass[ iAttacker ] )
		return FMRES_IGNORED;
	
	new Float:fOrigin[ 3 ];
	pev( iEnt, pev_origin, fOrigin );
	
	engfunc( EngFunc_RemoveEntity, iEnt );
	
	message_begin( MSG_BROADCAST, SVC_TEMPENTITY );
	write_byte( TE_EXPLOSION );
	engfunc( EngFunc_WriteCoord, fOrigin[ 0 ] );
	engfunc( EngFunc_WriteCoord, fOrigin[ 1 ] );
	engfunc( EngFunc_WriteCoord, fOrigin[ 2 ] );
	write_short( giSprite );
	write_byte( 32 );
	write_byte( 20 );
	write_byte( 0 );
	message_end( );
	
	new iPlayer = -1;
	while( ( iPlayer = fm_find_ent_in_sphere( iPlayer, fOrigin, 300.0 ) ) != 0 )
	{
		if( !is_user_alive( iPlayer ) && iPlayer != iAttacker )
			continue;
		
		ExecuteHam( Ham_TakeDamage, iPlayer, iAttacker, iAttacker, 25.0, DMG_BLAST );
	}
	
	return HAM_IGNORED;
}