#include < amxmodx >
#include < hamsandwich >
#include < fakemeta_util >
#include < ColorChat >

#include "ncodmod.inc"

new bool:gbHasClass[ 33 ] = false;
new giRocketsNum[ 33 ];
new Float:gfNextAttack[ 33 ];
new giSprite;

native ks_addUserKS( id, iKS );

public plugin_init( )
{
	ncod_registerClass( 
		"Barack Obama [ Premium ]",
		"Posiada awp 1/2, krowe 1/10, deagle 1/6 i 3 rakietki. Ma 1/4 szans na odrodzenie się po śmierci.",
		0, 50, 50, 25,
		( 1 << CSW_AWP | 1 << CSW_M249 | CSW_DEAGLE ),
		NCODTEAM_AMERICA,
		ADMIN_LEVEL_D
	);
	
	RegisterHam( Ham_TakeDamage, "player", "hamTakeDamage" );
	RegisterHam( Ham_Killed, "player", "hamKilledPost", 1 );
	
	register_forward( FM_Touch, "fwTouch" );
	
	ncod_registerHUDAddon( );
}

public plugin_precache( )
{
	giSprite = precache_model( "sprites/dexplo.spr" );
	precache_model( "models/rpgrocket.mdl" );
}

public ncod_classChangeState( id, iClass, NCodState:iState )
{
	switch( iState )
	{
		case NCODSTATE_DISABLE: 
			gbHasClass[ id ] = false;
		
		case NCODSTATE_ENABLE: 
			gbHasClass[ id ] = true;
		
		case NCODSTATE_USE: 
		{
			if( !is_user_alive( id ) )
				return ;
			
			if( !giRocketsNum[ id ] )
			{
				ncod_printInformation( id, NCODINFOTYPE_CHAT, NCODINFOCOLOR_NORMAL, "Nie posiadasz wiecej rakiet !" );
				return;

			}
			if( gfNextAttack[ id ] >= get_gametime() )
			{
				ncod_printInformation( id, NCODINFOTYPE_CHAT, NCODINFOCOLOR_NORMAL, "Rakiet mozesz uzywac co 2 sekundy!" );
			}
			else
			{
				gfNextAttack[ id ] = get_gametime() + 2.0;
				giRocketsNum[ id ] --;

				new Float:fTemp[ 3 ];

				new iRocket = engfunc( EngFunc_CreateNamedEntity, engfunc( EngFunc_AllocString, "info_target" ) );
				set_pev( iRocket, pev_classname, "ncod_rocket" );
				engfunc( EngFunc_SetModel, iRocket, "models/rpgrocket.mdl" );

				pev( id, pev_v_angle, fTemp );
				fTemp[ 0 ] *= -1.0;
				set_pev( iRocket, pev_angles, fTemp );
				
				pev( id, pev_origin, fTemp );
				set_pev( iRocket, pev_origin, fTemp );

				set_pev( iRocket, pev_effects, 2 );
				set_pev( iRocket, pev_solid, SOLID_BBOX );
				set_pev( iRocket, pev_movetype, MOVETYPE_FLY )
				set_pev( iRocket, pev_owner, id )

				velocity_by_aim( id, 1000, fTemp );
				set_pev( iRocket, pev_velocity, fTemp );
			}
		}
		
		case NCODSTATE_SPAWN:
			giRocketsNum[ id ] = 3;
		
		default: return;
	}
}

public ncod_hudRefresh( id, szText[ 128 ] ))
{
	if( !gbHasClass[ id ] )
		return;
		
	formatex( szText, 127, "[ Rakiety ]: %d", giRocketsNum[ id ] );
}

public hamTakeDamage( iThis, iInflictor, iAttacker, Float:fDamage, iDamageBits )
{
	if( !is_user_connected( iAttacker ) || !gbHasClass[ iAttacker ] )
		return HAM_IGNORED;
		
	switch( get_user_weapon( iAttacker ) )
	{
		case CSW_AWP: if( random( 1 ) ) return HAM_IGNORED;
		case CSW_M249: if( random( 9 ) ) return HAM_IGNORED;
		case CSW_DEAGLE: if( random( 5 ) ) return HAM_IGNORED;
		
		default: return HAM_IGNORED;
	}
	
	set_pev( iThis, pev_armorvalue, 0 );
	SetHamParamFloat( 4, pev( iThis, pev_health ) + 1.0 );
	
	return HAM_HANDLED ;
}

public hamKilledPost( id, iAttacker, iShouldgibs )
{
	if( gbHasClass[ id ] && !random( 3 ) )
		ExecuteHamB( Ham_CS_RoundRespawn, id );
}

public fwTouch( iEnt, iSomethink )
{
	if( !pev_valid( iEnt ) )
		return FMRES_IGNORED;

	new szClassName[ 33 ];
	pev( iEnt, pev_classname, szClassName, 32 );
	
	if( !equali( szClassName, "ncod_rocket" ) )
		return FMRES_IGNORED;
		
	new iAttacker = pev( iEnt, pev_owner );
	
	if( !gbHasClass[ iAttacker ] )
		return FMRES_IGNORED;
		
	engfunc( EngFunc_RemoveEntity, iEnt );
	
	new Float:fOrigin[ 3 ];
	pev( iEnt, pev_origin, fOrigin );
	
	message_begin( MSG_BROADCAST, SVC_TEMPENTITY );
	write_byte( TE_EXPLOSION );
	engfunc( EngFunc_WriteCoord, fOrigin[ 0 ] );
	engfunc( EngFunc_WriteCoord, fOrigin[ 1 ] );
	engfunc( EngFunc_WriteCoord, fOrigin[ 2 ] );
	write_short( giSprite );
	write_byte( 32 );
	write_byte( 20 );
	write_byte( 0 );
	message_end( );
	
	new iPlayer = -1;
	while( ( iPlayer = fm_find_ent_in_sphere( iPlayer, fOrigin, 300.0 ) ) != 0 )
	{
		if( !is_user_alive( iPlayer ) || get_user_team( iPlayer ) == get_user_team( iAttacker ) )
			continue;
		
		ExecuteHam( Ham_TakeDamage, iPlayer, iAttacker, iAttacker, 30.0, DMG_BLAST );
	}
	
	return HAM_IGNORED;
}