#include < amxmodx >
#include < hamsandwich >
#include < fakemeta_util >
#include < ColorChat >

#include "ncodmod.inc"

new bool:gbHasClass[ 33 ] = false;
new giMedkits[ 33 ]; 

public plugin_init( )
{
	ncod_registerClass( 
		"General [ Premium ]",
		"Posiada MP5 1/10, usp 1/5, scouta 1/2, 3 apteczki. Gdy kuca jest mniej widoczny.",
		25, 25, 15, 30,
		( 1 << CSW_MP5NAVY | 1 << CSW_USP | 1 << CSW_SCOUT ),
		NCODTEAM_AMERICA,
		ADMIN_LEVEL_D
	);
	
	RegisterHam( Ham_TakeDamage, "player", "hamTakeDamage" );

	register_forward( FM_CmdStart, "fwCmdStart" );
	
	ncod_registerHUDAddon( );
}

public ncod_classChangeState( id, iClass, NCodState:iState )
{
	switch( iState )
	{
		case NCODSTATE_DISABLE: 
			gbHasClass[ id ] = false;
		
		case NCODSTATE_ENABLE: 
			gbHasClass[ id ] = true;
		
		case NCODSTATE_USE: 
		{
				if( !giMedkits[ id ] )
				{
					ncod_printInformation( id, NCODINFOTYPE_CHAT, NCODINFOCOLOR_NORMAL, "Nie posiadasz wiecej apteczek !" );
					return;
				}
				
				new Float:fMaxHealth = 100.0 + ncod_getUserStatist( id, NCODSTATIST_HEALTH );
				if( get_user_health( id ) == fMaxHealth )
					return;
					
				giMedkits[ id ] --;
					
				set_pev( id, pev_health, fMaxHealth );
		}
		
		case NCODSTATE_SPAWN:
			giMedkits[ id ] = 3;
		
		default: return;
	}
}

public ncod_hudRefresh( id, szText[ 128 ] )
{
	if( !gbHasClass[ id ] )
		return;
		
	formatex( szText, 127, "[ Apteczki ]: %d", giMedkits[ id ] );
}

public hamTakeDamage( iThis, iInflictor, iAttacker, Float:fDamage, iDamageBits )
{
	if( !is_user_connected( iAttacker ) || !gbHasClass[ iAttacker ] )
		return HAM_IGNORED;
		
	switch( get_user_weapon( iAttacker ) )
	{
		case CSW_MP5NAVY: if( random( 9 ) ) return HAM_IGNORED;
		case CSW_USP: if( random( 4 ) ) return HAM_IGNORED;
		case CSW_SCOUT: if( random( 1 ) ) return HAM_IGNORED;
		
		default: return HAM_IGNORED;
	}
	
	set_pev( iThis, pev_armorvalue, 0 );
	SetHamParamFloat( 4, pev( iThis, pev_health ) + 1.0 );
	
	return HAM_HANDLED ;
}


public fwCmdStart( id, iUC )
{
	if( !is_user_alive( id ) || !gbHasClass[ id ] )
		return FMRES_IGNORED;
		
	if( get_uc( iUC, UC_Buttons ) & IN_DUCK )
		fm_set_user_rendering( id, kRenderFxGlowShell, 0, 0, 0, kRenderTransAlpha, 90 );
	else
		fm_set_user_rendering( id, kRenderFxGlowShell, 0, 0, 0, kRenderTransAlpha, 255 );
		
	return FMRES_IGNORED;
}