#include < amxmodx >
#include < hamsandwich >
#include < fakemeta_util >
#include < ColorChat >

#include < ncodmod >

new bool:gbHasClass[ 33 ] = false;
new bool:gbHasRocket[ 33 ] = false; 
new giSprite;

native ks_addUserKS( id, iKS );

public plugin_init( )
{
	ncod_registerClass( 
		"Lotnik",
		"Może latać rakietą (klawisz E), posiada SG-552, deagle. Ma 1/6 szans przy zabiciu wroga na dostanie AIRSTRIKE",
		0, 0, 20, 5,
		( 1 << CSW_SG552 | 1 << CSW_DEAGLE ),
		NCODTEAM_AMERICA
	);
	
	RegisterHam( Ham_Killed, "player", "hamKilledPost", 1 );
	register_forward( FM_Touch, "fwTouch" );
}

public plugin_precache( )
{
	giSprite = precache_model( "sprites/dexplo.spr" );
	precache_model( "models/cod_predator.mdl" );
}

public ncod_classChangeState( id, iClass, NCodState:iState )
{
	switch( iState )
	{
		case NCODSTATE_DISABLE: 
			gbHasClass[ id ] = false;
		
		case NCODSTATE_ENABLE: 
			gbHasClass[ id ] = true;
		
		case NCODSTATE_USE: 
		{
				if( !gbHasRocket[ id ] )
					return;
				
				gbHasRocket[ id ] = false;
				
				new iRocket = engfunc( EngFunc_CreateNamedEntity, engfunc( EngFunc_AllocString, "info_target" ) );
				engfunc( EngFunc_SetModel, iRocket, "models/cod_predator.mdl" );
				
				new Float:vBuffer[ 3 ];
				pev( id, pev_origin, vBuffer );
				engfunc( EngFunc_SetOrigin, iRocket, vBuffer );
				
				set_pev( iRocket, pev_classname, "ncod_missle" )
				set_pev( iRocket, pev_solid, SOLID_BBOX )
				set_pev( iRocket, pev_movetype, 5 )
				set_pev( iRocket, pev_owner, id )
				
				pev( id, pev_v_angle, vBuffer );
				set_pev( iRocket, pev_angles, vBuffer )
				
				velocity_by_aim( id, 700, vBuffer );
				set_pev( iRocket, pev_velocity, vBuffer )
			
				engfunc( EngFunc_SetView, id, iRocket );
				
				set_pev( id, pev_origin, Float: { -8192.0 , -8192.0 , -8192.0 } );
				fm_set_user_godmode( id, 1 );
				fm_set_user_noclip( id, 1 );
		}
		
		case NCODSTATE_SPAWN:
			gbHasRocket[ id ] = true;
		
		default: return;
	}
}

public hamKilledPost( iThis, iAttacker, iShouldgibs )
{
	if( !is_user_connected( iAttacker ) || !gbHasClass[ iAttacker ] || random( 5 ) != 0 )
		return HAM_IGNORED;
		
	ks_addUserKS( iAttacker, 4 );
	return HAM_IGNORED;
}

public fwTouch( iEnt, iSomethink )
{
	new szClassName[ 33 ];
	pev( iEnt, pev_classname, szClassName, 32 );
	
	if( !pev_valid( iEnt ) || !equali( szClassName, "ncod_missle" ) )
		return FMRES_IGNORED;
		
	new iAttacker = pev( iEnt, pev_owner );
	new Float:fOrigin[ 3 ];
	pev( iEnt, pev_origin, fOrigin );
	
	engfunc( EngFunc_SetView, iAttacker, iAttacker );
	engfunc( EngFunc_RemoveEntity, iEnt );
	
	message_begin( MSG_BROADCAST, SVC_TEMPENTITY );
	write_byte( TE_EXPLOSION );
	engfunc( EngFunc_WriteCoord, fOrigin[ 0 ] );
	engfunc( EngFunc_WriteCoord, fOrigin[ 1 ] );
	engfunc( EngFunc_WriteCoord, fOrigin[ 2 ] );
	write_short( giSprite );
	write_byte( 32 );
	write_byte( 20 );
	write_byte( 0 );
	message_end( );
	
	new iPlayer = -1;
	while( ( iPlayer = fm_find_ent_in_sphere( iPlayer, fOrigin, 300.0 ) ) != 0 )
	{
		if( !is_user_alive( iPlayer ) || get_user_team( iPlayer ) == get_user_team( iAttacker ) )
			continue;
		
		ExecuteHam( Ham_TakeDamage, iPlayer, iAttacker, iAttacker, random_float( 25.0, 50.0 ), DMG_BLAST );
	}
				
	set_pev( iAttacker, pev_origin, fOrigin );
	fm_set_user_godmode( iAttacker, 0 );
	fm_set_user_noclip( iAttacker, 0 );
	
	return HAM_IGNORED;
}