#include < amxmodx >
#include < hamsandwich >
#include < fakemeta_util >
#include < ColorChat >

#include "ncodmod.inc"

new bool:gbHasClass[ 33 ] = false;
new giMinesNum[ 33 ];
new giSprite;

public plugin_init( )
{
	ncod_registerClass( 
		"Saper",
		"Posiada fn p90, usp, 3 miny. Ma 1/12 szans na oślepienie wroga przy strzale.",
		15, 0, 5, 10,
		( 1 << CSW_P90 | 1 << CSW_USP ),
		NCODTEAM_AMERICA
	);
	
	RegisterHam( Ham_TakeDamage, "player", "hamTakeDamage" );
	register_forward( FM_Touch, "fwTouch" );
	
	ncod_registerHUDAddon( );
}

public plugin_precache( )
{
	giSprite = precache_model( "sprites/blast.spr" ) ;
	precache_model( "models/NCodMod/mine.mdl" );
}

public ncod_classChangeState( id, iClass, NCodState:iState )
{
	switch( iState )
	{
		case NCODSTATE_DISABLE: 
			gbHasClass[ id ] = false;
		
		case NCODSTATE_ENABLE: 
			gbHasClass[ id ] = true;
		
		case NCODSTATE_USE: 
		{
			if( !is_user_alive( id ) )
				return ;
			
			if( !giMinesNum[ id ] )
			{
				ncod_printInformation( id, NCODINFOTYPE_CHAT, NCODINFOCOLOR_NORMAL, "Nie masz wiecej min!" );
				return;
			}
			
			giMinesNum[ id ] --;
			
			new Float:fOrigin[ 3 ];
			pev( id, pev_origin, fOrigin );

			new iMine = engfunc( EngFunc_CreateNamedEntity, engfunc( EngFunc_AllocString, "info_target" ) );

			set_pev( iMine, pev_classname, "ncod_mine" );
			set_pev( iMine, pev_owner, id );
			set_pev( iMine, pev_movetype, MOVETYPE_TOSS );
			set_pev( iMine, pev_solid, SOLID_BBOX );

			engfunc( EngFunc_SetModel, iMine, "models/NCodMod/mine.mdl" )
			engfunc( EngFunc_SetSize, iMine, Float:{ -16.0, -16.0, 0.0 }, Float:{ 16.0, 16.0, 2.0 } );
			engfunc( EngFunc_DropToFloor, iMine );

			fm_set_rendering( iMine, kRenderFxNone, 0, 0, 0, kRenderTransTexture, 50 );
		}
		
		case NCODSTATE_SPAWN:
			giMinesNum[ id ] = 3;
		
		default: return;
	}
}

public ncod_hudRefresh( id, szText[ 128 ] )
{
	if( !gbHasClass[ id ] )
		return;
		
	format( szText, 127, "[ Miny ]: %d", giMinesNum[ id ] );
}

public hamTakeDamage( iThis, iInflictor, iAttacker, Float:fDamage, iDamageBits )
{
	if( !is_user_connected( iAttacker ) || gbHasClass[ iAttacker ] && !random( 11 ))
		displayFade( iThis, 1<<14, 1<<14, 1<<16, { 255, 155, 50, 230 } );
	
	return HAM_IGNORED ;
}

public fwTouch( id, iEnt )
{
	if( !pev_valid( iEnt ) )
		return FMRES_IGNORED;

	new szClassName[ 33 ];
	pev( iEnt, pev_classname, szClassName, 32 );
	
	if( !is_user_alive( id ) || !equali( szClassName, "ncod_mine" ) )
		return FMRES_IGNORED;
		
	new iAttacker = pev( iEnt, pev_owner );
	
	if( !gbHasClass[ iAttacker ] )
		return FMRES_IGNORED;
	
	new Float:fOrigin[ 3 ];
	pev( iEnt, pev_origin, fOrigin );
	
	engfunc( EngFunc_RemoveEntity, iEnt );
	
	message_begin( MSG_BROADCAST, SVC_TEMPENTITY );
	write_byte( TE_EXPLOSION );
	engfunc( EngFunc_WriteCoord, fOrigin[ 0 ] );
	engfunc( EngFunc_WriteCoord, fOrigin[ 1 ] );
	engfunc( EngFunc_WriteCoord, fOrigin[ 2 ] );
	write_short( giSprite );
	write_byte( 32 );
	write_byte( 20 );
	write_byte( 0 );
	message_end( );
	
	ExecuteHamB( Ham_TakeDamage, id, iAttacker, iAttacker, 45.0, DMG_BLAST );
	
	return HAM_IGNORED;
}

stock displayFade( id, iDuration, iHoldtime, iFadetype, iRGBA[ 4 ] )
{
        message_begin( MSG_ONE, get_user_msgid( "ScreenFade" ), {0,0,0}, id );
        write_short( iDuration );        // Duration of fadeout
        write_short( iHoldtime );        // Hold time of color
        write_short( iFadetype );        // Fade type
        write_byte ( iRGBA[ 0 ] );             // Red
        write_byte ( iRGBA[ 1 ] );           // Green
        write_byte ( iRGBA[ 2 ] );            // Blue
        write_byte ( iRGBA[ 3 ] );   // Alpha
        message_end( );
}