#include < amxmodx >
#include < fakemeta_util >
#include < hamsandwich >

#include "ncodmod.inc"

new bool: gHasPerk[ 33 ] = { false };

public plugin_init( )
{
	ncod_registerPerk( 
			"Przeciwodlamkowy",
			"Odpornosc na wybuchy i ogien"
	);
	
	RegisterHam( Ham_TakeDamage, "player", "hamTakeDamage" )
}

public hamTakeDamage( iThis, iInflictor, iAttacker, Float: fDamage, iDamageBits )
{
	if( ! gHasPerk[ iThis ] )
		return HAM_IGNORED;
		
	if( iDamageBits & ( DMG_BLAST | DMG_BURN ) )
		return HAM_SUPERCEDE;
		
	return HAM_IGNORED;
}

public ncod_perkChangeState( id, iPerk, NCodState: iState )
{
	switch( iState )
	{
		case NCODSTATE_ENABLE: gHasPerk[ id ] = true;
		case NCODSTATE_DISABLE: gHasPerk[ id ] = false;
		default: {}
	}
}